﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Xml.Linq;

namespace PlikiXML
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //odczytajUstawieniaZPlikuXml();
            //ZapełnijDrzewo(treeView, "ustawienia.xml");
            ZapełnijDrzewo(treeView, "http://www.nbp.pl/kursy/xml/LastC.xml");
        }

        private void zapiszUstawieniaWPlikuXml()
        {
            XDocument xml = new XDocument(
                new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("Geometria okna"),
                new XElement("korzeń",
                    new XElement("położenie",
                        new XElement("X", this.Left),
                        new XElement("Y", this.Top)
                    ),
                    new XElement("rozmiar",
                        new XElement("W", this.Width),
                        new XElement("H", this.Height)
                    )
                )
            );
            xml.Root.Add(new XComment("komentarz"));
            xml.Save("ustawienia.xml");
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            zapiszUstawieniaWPlikuXml();
        }

        private void odczytajUstawieniaZPlikuXml()
        {
            XDocument xml = XDocument.Load("ustawienia.xml");

            string left = xml.Root.Element("położenie").Element("X").Value;
            this.Left = int.Parse(left);
            string top = xml.Root.Element("położenie").Element("Y").Value;
            this.Top = int.Parse(top);

            string width = xml.Root.Element("rozmiar").Element("W").Value;
            this.Width = int.Parse(width);
            string height = xml.Root.Element("rozmiar").Element("H").Value;
            this.Height = int.Parse(height);
        }

        private void DodajWęzeł(XElement elementXml, TreeViewItem treeNode)
        {
            IEnumerable<XElement> elementy = elementXml.Elements();
            foreach (XElement element in elementy)
            {
                string opis = element.Name.LocalName;
                if (!element.HasElements && !string.IsNullOrEmpty(element.Value)) opis += " " + element.Value.ToString();
                TreeViewItem newNode = new TreeViewItem()
                {
                    Header = opis,
                    IsExpanded = true
                };
                treeNode.Items.Add(newNode);
                DodajWęzeł(element, newNode);
            }
        }

        public void ZapełnijDrzewo(TreeView tv, string nazwaPliku)
        {
            tv.Items.Clear();

            XDocument xml = XDocument.Load(nazwaPliku);
            TreeViewItem rootNode = new TreeViewItem()
            {
                Header = xml.Root.Name.LocalName,
                IsExpanded = true
            };
            tv.Items.Add(rootNode);

            tv.BeginInit();
            DodajWęzeł(xml.Root, rootNode);
            tv.EndInit();
        }
    }
}
